#!/usr/bin/perl

# $Id$
#Autor: mundacho
#email: mundacho@bigfoot.com
#Descripcion:
#Este es un pequenho programa que escribi para actualiuar automaticamente mi 
#sitio web, o sea, sincronizarlo con mi mquina. La forma de utilizar es simple:
#te pones en el directorio donde est tu web localmente y llamas al script con 
#los parametros de esta manera
#	./sincronizador [-q] usuario passwd ftp.tuservidor.com
#Yo lo uso personalmente, pero no tomo ninguna responsabilidad por tu sitio web
#si tu decides usarlo, el programa se da sin garantia alguna y con fines
#didacticos, espero q lo disfruten, envienme sus comentarios.
#Se puede distribuir o modificar libremente siempre y cuando se mencione la
#fuente.
#

use strict;
use warnings;

use Net::FTP;
use File::stat;

if ($#ARGV <= 2) {
	die "Uso: $0 [-q] usuario passwd ftp.servidor.com";
}
my ($argument, $usuario, $passwd, $servidor) = @ARGV;
my $quiet = 0;
if ($argument eq "-q"){
	$quiet = 1;
}
my @no_tomar_cuenta = ("CVS", ".sincronizador.pl.swp", "sincronizador.pl", ".", "..", ".DS_Store");
print "Conectando a $servidor\n";
my $ftp = Net::FTP->new($servidor, Debug=> 0) or die "No se pudo conectar al servidor: $servidor";
print "Autenticandose\n";
$ftp->login($usuario,$passwd) or die "No se puede autenticar: ", $ftp->message;
sincronizardir(".");
print "Terminado sin problemas.\n";
print "Desconectandose\n";
$ftp->quit;

sub sincronizardir {
my $ndirlocal = shift;
my $file;
my (@dirremoto, @dirlocal, @directorios);
my (%dirr, %dirl,%directoriosr);
printq ("Cambiando al directorio $ndirlocal en la mquina local\n");
chdir ($ndirlocal) or die "No se pudo cambiar de directorio";
printq ("Directorio en la mquina local: $ndirlocal\n");
printq ("Cambiando al directorio $ndirlocal en la mquina remota\n");
$ftp->cwd($ndirlocal);
printq("Directorio en la mquina remota: " . $ftp->pwd . "\n");
opendir(DIR, ".") or die "No se pudo abrir el directorio: $ndirlocal";
@dirlocal = readdir (DIR);
@dirremoto =  $ftp->dir;
#sacamos a los indeseables
foreach $file (@no_tomar_cuenta) {
	my $j = 0;
	for (my $i=0; $i <= $#dirlocal; $i++){
		if ($file eq $dirlocal[$i]) {
			splice(@dirlocal, $i-$j, 1);
			$j++;
		}
	}
}
foreach my $archivo (@dirlocal){
	my $sb = stat($archivo);
	if ( -d $archivo ){
		push @directorios, $archivo;
	}
	else {
		$dirl{$archivo} = $sb->size;
	}
}
foreach (@dirremoto){
	my @temp;
	my $a;
	@temp = split / +/, $_;
	$a = substr($temp[0], 0,1);
	if ( $a ne 'd'){
		$dirr{$temp[8]} = $temp[4];
	}
	else {
		$directoriosr{$temp[8]} = 1;
	}
}
#Aqui creamos un directorio que antes de existia en el servidor
foreach (@directorios) {
	if ( !exists $directoriosr{$_}){
		print "Creando nuevo direcctorio $_ en el folder remoto\n";
		$ftp->mkdir($_);
	}
}
#Aqui eliminamos los archivos que estn all pero no aqu
foreach my $llave (keys %dirr){
	if ( !exists $dirl{$llave}) {
		print "Borrando archivo $llave del servidor\n";
		delete $dirr{$llave};
		$ftp->delete("$llave");
	}
}
#Aqui subimos los archivos que no tienen el mismo tamao
foreach my $llave (keys %dirl){
	if ( !exists $dirr{$llave} or $dirl{$llave} != $dirr{$llave}) {
		print "Subiendo archivo $llave al servidor\n";
		$ftp->put($llave);
	}
}
foreach (@directorios){
	sincronizardir($_); #Sincronizamos todos los directorios hacia abajo
}
chdir("..");
$ftp->cwd("..");
}
sub printq {
	my $argumento = shift;
	if ($quiet != 1){
		print $argumento;
	}
}
